# TODO:
# - init scripts
# - configuration files
# - pam configs
Summary:	Secure Remote Password protocol
Summary(pl.UTF-8):	Protokół SRP (bezpieczny system autoryzacji)
Name:		srp
Version:	2.1.2
Release:	5
License:	SRP Open Source
Group:		Applications/Networking
Source0:	http://srp.stanford.edu/source/%{name}-%{version}.tar.gz
# Source0-md5:	39d150d2fcfcea1646c405172b748119
Patch0:		%{name}-shared.patch
Patch1:		%{name}-paths.patch
Patch2:		%{name}-cflags.patch
Patch3:		%{name}-getline.patch
Patch4:		%{name}-format.patch
Patch5:		%{name}-bison.patch
URL:		http://srp.stanford.edu/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	bison
BuildRequires:	libtool
BuildRequires:	ncurses-devel
BuildRequires:	openssl-devel >= 0.9.7
BuildRequires:	pam-devel
BuildRequires:	zlib-devel
Requires:	%{name}-libs = %{version}-%{release}
Requires:	pam >= 0.77.3
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
SRP stands for the Secure Remote Password protocol, and it represents
a new mechanism for performing password-based authentication and key
exchange over potentially insecure networks. SRP offers both security
and convenience improvements over authentication techniques currently
in use.

%description -l pl.UTF-8
SRP oznacza protokół Secure Remote Password i reprezentuje nowy
mechanizm autentyfikacji bazującej na hasłach oraz wymianę kluczy
przez potencjalnie niebezpieczne sieci. SRP oferuje zarówno
bezpieczeństwo i ulepszenia w stosunku do innych aktualnie dostępnych
technik autentyfikacji.

%package libs
Summary:	Shared SRP libraries
Summary(pl.UTF-8):	Współdzielone biblioteki SRP
Group:		Libraries

%description libs
Shared SRP libraries.

%description libs -l pl.UTF-8
Współdzielone biblioteki SRP.

%package devel
Summary:	Headers files for SRP libraries
Summary(pl.UTF-8):	Pliki nagłówkowe bibliotek SRP
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}
Requires:	openssl-devel

%description devel
Headers files for SRP libraries.

%description devel -l pl.UTF-8
Pliki nagłówkowe bibliotek SRP.

%package static
Summary:	Static SRP libraries
Summary(pl.UTF-8):	Statyczne biblioteki SRP
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static SRP libraries.

%description static -l pl.UTF-8
Statyczne biblioteki SRP.

%package telnet
Summary:	Telnet client with SRP and IPv6 support
Summary(pl.UTF-8):	Klient protokołu telnet ze wsparciem dla SRP i IPv6
Group:		Applications/Networking
Requires:	%{name} = %{version}-%{release}

%description telnet
Telnet client with Secure Remote Password protocol and IPv6 support.

%description telnet -l pl.UTF-8
Klient protokołu telnet ze wsparciem dla protokołu Secure Remote
Password i IPv6.

%package telnetd
Summary:	Telnet server with SRP and IPv6 support
Summary(pl.UTF-8):	Serwer protokołu telnet ze wsparciem dla SRP i IPv6
Group:		Networking/Daemons
Requires:	%{name} = %{version}-%{release}

%description telnetd
Telnet server with Secure Remote Password protocol and IPv6 support.

%description telnetd -l pl.UTF-8
Serwer protokołu telnet ze wsparciem dla protokołu Secure Remote
Password i IPv6.

%package ftp
Summary:	FTP client with SRP support
Summary(pl.UTF-8):	Klient FTP ze wsparciem dla SRP
Group:		Networking/Daemons
Requires:	%{name} = %{version}-%{release}

%description ftp
FTP client with Secure Remote Password protocol support.

%description ftp -l pl.UTF-8
Klient FTP ze wsparciem dla protokołu Secure Remote Password.

%package ftpd
Summary:	FTP server with SRP support
Summary(pl.UTF-8):	Serwer FTP ze wsparciem dla SRP
Group:		Networking/Daemons
Requires:	%{name} = %{version}-%{release}

%description ftpd
FTP server with Secure Remote Password protocol support.

%description ftpd -l pl.UTF-8
Serwer FTP ze wsparciem dla protokołu Secure Remote Password.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

%build
cd libsrp
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
cd ../libkrypto
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
cd ../telnet
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
cd ../ftp
# workaround: install-sh missing here, AUX_DIR not defined explicitly
touch install-sh
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
cd ../base
# see above
touch install-sh
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
cd ..
%{__aclocal}
%{__autoconf}
%{__automake}
%configure \
	LIBTERM="-ltinfo" \
	MAILSPOOL=/var/mail \
	MAILFILE=Mail \
	UTMPDIR=/var/run \
	WTMPDIR=/var/log \
	FAILLOGDIR=/var/log \
	LASTLOGDIR=/var/log \
	--enable-shadowgrp \
	--with-cast \
	--with-engine \
	--with-libcrack \
	--with-openssl \
	--with-pam \
	--with-srp \
	--with-zlib

	# --with-inet6  - requires non-existing "support.h" in telnet/telnet/commands.c
	# ??? [needs check] PAM support in passwd.srp is broken (it probably
	# doesn't use pass specified by user.
	# --with-spx	- SPX requires kerberos ;-(
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/{pam.d,rc.d/init.d,sysconfig},/bin,/sbin}

#install %{SOURCE1}			$RPM_BUILD_ROOT/etc/pam.d/passwd.srp
touch $RPM_BUILD_ROOT%{_sysconfdir}/tpasswd

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	SECUREDIR=/%{_lib}/security \
	FAKEROOT=$RPM_BUILD_ROOT \
	suidbins= \
	suidubins=

install base/src/su $RPM_BUILD_ROOT/bin/su
install base/src/passwd $RPM_BUILD_ROOT%{_bindir}/passwd

mv -f $RPM_BUILD_ROOT/bin/su		$RPM_BUILD_ROOT/bin/su.srp
mv -f $RPM_BUILD_ROOT%{_bindir}/login	$RPM_BUILD_ROOT/bin/login.srp
mv -f $RPM_BUILD_ROOT%{_bindir}/passwd	$RPM_BUILD_ROOT%{_bindir}/passwd.srp
mv -f $RPM_BUILD_ROOT%{_bindir}/tconf	$RPM_BUILD_ROOT%{_sbindir}/tconf

mv -f $RPM_BUILD_ROOT%{_bindir}/ftp	$RPM_BUILD_ROOT%{_bindir}/ftp.srp
mv -f $RPM_BUILD_ROOT%{_bindir}/telnet	$RPM_BUILD_ROOT%{_bindir}/telnet.srp

mv -f $RPM_BUILD_ROOT%{_sbindir}/ftpd	$RPM_BUILD_ROOT%{_sbindir}/ftpd.srp
mv -f $RPM_BUILD_ROOT%{_sbindir}/telnetd $RPM_BUILD_ROOT%{_sbindir}/telnetd.srp

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc docs/* inst/INSTALL*
%attr(755,root,root) /bin/login.srp
%attr(4755,root,root) /bin/su.srp
%attr(755,root,root) %{_sbindir}/tconf
%attr(4755,root,root) %{_bindir}/passwd.srp
%attr(600,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/tpasswd
#%attr(640,root,root) %config(noreplace) %verify(not size mtime md5) /etc/pam.d/*
# Pam modules are required by main srp package so we don't split them
%attr(4755,root,root) /sbin/eps_chkpwd
%attr(755,root,root) /%{_lib}/security/pam_eps_*.so

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libkrypto.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libkrypto.so.0
%attr(755,root,root) %{_libdir}/libsrp.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libsrp.so.0

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libkrypto.so
%attr(755,root,root) %{_libdir}/libsrp.so
%{_libdir}/libkrypto.la
%{_libdir}/libsrp.la
%{_includedir}/cstr.h
%{_includedir}/krypto.h
%{_includedir}/srp*.h
%{_includedir}/t_*.h

%files static
%defattr(644,root,root,755)
%{_libdir}/libkrypto.a
%{_libdir}/libsrp.a

%files telnet
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/telnet.srp

%files telnetd
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/telnetd.srp

%files ftp
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/ftp.srp

%files ftpd
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/ftpd.srp
%changelog
* Wed Feb 25 2015 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/srp.git;a=log;h=master

* Tue Feb 24 2015 Jan Rękorajski <baggins@pld-linux.org> 10b3c86
- x32 rebuild
- release 5 (by relup.sh)

* Sun Feb 16 2014 Jakub Bogusz <qboosh@pld-linux.org> 4029f1f
- added format patch (fixes build with -Werror=format-security)
- added bison patch (fixes yacc syntax to be compatible with recent bison)

* Wed Aug 31 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> c410b21
- release 4

* Sat Apr 10 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 3e60045
- release 3

* Fri Aug 28 2009 Arkadiusz Miśkiewicz <arekm@maven.pl> 8ebc87a
- rel 2; build fixed

* Sat Nov 01 2008 Jakub Bogusz <qboosh@pld-linux.org> cdcdfae
- more sane workarounds
- ghost soname symlinks

* Sat Nov 01 2008 Jakub Bogusz <qboosh@pld-linux.org> 88c7d0a
- cleanup

* Sat Nov 01 2008 Arkadiusz Miśkiewicz <arekm@maven.pl> 729beb2
- hack

* Mon Apr 28 2008 Arkadiusz Miśkiewicz <arekm@maven.pl> 6773290
- rel 1

* Sat Apr 07 2007 Jakub Bogusz <qboosh@pld-linux.org> a1e2336
- up to 2.1.2 (fixes CVE-2007-0956)

* Mon Feb 12 2007 Elan Ruusamäe <glen@pld-linux.org> 36d1012
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> b1672a7
- converted to UTF-8

* Wed Aug 09 2006 Arkadiusz Miśkiewicz <arekm@maven.pl> 73ad961
- rel 0.2

* Sat Aug 05 2006 sparky <sparky@pld-linux.org> db2de12
- LDFLAGS = @LDFLAGS@

* Sat Aug 05 2006 sparky <sparky@pld-linux.org> 029d07a
- add LDFLAGS

* Mon Feb 27 2006 sparky <sparky@pld-linux.org> f93ee5f
- added cflags patch

* Mon Feb 27 2006 sparky <sparky@pld-linux.org> 2f92502
- build eps_chkpwd with proper CFLAGS

* Sun Dec 04 2005 Elan Ruusamäe <glen@pld-linux.org> 1056a1f
- adapterized (sorted %verify flags)

* Tue Apr 26 2005 Jakub Bogusz <qboosh@pld-linux.org> a66fa47
- updated to 2.1.1 (fixes CAN-2005-0468 CAN-2005-0469 in telnet)

* Sat Jan 08 2005 Jakub Bogusz <qboosh@pld-linux.org> 9c9bc85
- added paths patch, pass some paths to configure

